Unit DE02R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AME2R_p, DE04RQ_p, DE02RS_p, UTDE20_p;

procedure DE02R(FU :Proc_F_DE; M :Integer; var JSTART :Integer;
                var A :Array of Real; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var E1 :Array of Real; var E2 :Array of Real;
                var E3 :Array of Real; var E4 :Array of Real;
                var R :Array of Real; var R0 :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var R3 :Array of Real; var YD :Array of Real;
                var IERR :Integer);
implementation

procedure DE02R(FU :Proc_F_DE; M :Integer; var JSTART :Integer;
                var A :Array of Real; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var E1 :Array of Real; var E2 :Array of Real;
                var E3 :Array of Real; var E4 :Array of Real;
                var R :Array of Real; var R0 :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var R3 :Array of Real; var YD :Array of Real;
                var IERR :Integer);
var
I,J :Integer;
C1,EPS1 :Real;
BULD,BULEX,BULHM :Boolean;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160;
begin
IERR  := 0;
EPS1  := EPS/32.;
BULD  := True;
BULHM  := False;
BULEX  := False;
if ( JSTART ) < 0
 then goto _40
 else if ( JSTART ) > 0
       then goto _10
       else goto _60;
_10:
if ( JSTART  = 1 ) 
 then goto _80;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    E1[(J-1)+(I-1)*M] := E2[(J-1)+(I-1)*M];
_20:
   end;
_30:
 end;
goto _70;
_40:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_50:
 end;
X  := XP;
_60:
C1  := H/4.;
AME2R(A,C1,M,E1,R,E3,E4);
if ( BULEX ) 
 then goto _80;
_70:
DE04RQ(M,E1,E2);
_80:
C1  := H/2.;
DE02RS(FU,M,X,YX,H,E2,YD,R1,R2,R3);
DE02RS(FU,M,X,YX,C1,E1,R0,R1,R2,R3);
DE02RS(FU,M,X + C1,R0,C1,E1,R,R1,R2,R3);
for I:=1 to M do
 begin
  R1[I-1] := (R[I-1] - YD[I-1])/15.;
  C1  := Abs(R1[I-1]);
  if ( Abs(R[I-1])  >= P ) 
   then C1  := C1/Abs(R[I-1]);
  if ( C1  > EPS1 ) 
   then BULD  := False;
  if ( C1  >= EPS ) 
   then goto _120;
_90:
 end;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_100:
 end;
XP  := X;
for I:=1 to M do
 begin
  YX[I-1] := R[I-1];
_110:
 end;
X  := X + H;
if ( BULD ) 
 then H  := H*2.;
goto _160;
_120:
if ( BULHM ) 
 then goto _150;
H  := H/2.;
BUL  := False;
BULEX  := True;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    E2[(J-1)+(I-1)*M] := E1[(J-1)+(I-1)*M];
_130:
   end;
_140:
 end;
if ( Abs(H)  > Abs(HMIN) ) 
 then goto _60;
H  := Sign(HMIN,H);
BULHM  := True;
BULEX  := False;
goto _60;
_150:
IERR  := 65;
UTDE20(IERR,2);
_160:
JSTART  := 1;
if ( BULD )
 then JSTART  := 2;
end;

end.
